Subject: Re: [PATCH] netfilter: use per-cpu spinlock rather than RCU (v3)

From: Patrick McHardy <[email-masked]>
Date: Thu, 16 Apr 2009 15:11:31 +0200

Linus Torvalds wrote:
> On Wed, 15 Apr 2009, Stephen Hemminger wrote:
>> The counters are the bigger problem, otherwise we could just free table
>> info via rcu.  Do we really have to support: replace where the counter
>> values coming out to user space are always exactly accurate, or is it
>> allowed to replace a rule and maybe lose some counter ticks (worst case
>> NCPU-1).
> 
> Why not just read the counters fromt he old one at RCU free time (they are 
> guaranteed to be stable at that point, since we're all done with those 
> entries), and apply them at that point to the current setup?

We need the counters immediately to copy them to userspace, so waiting
for an asynchronous RCU free is not going to work.